/*********************************
 *********************************
 **     EXEMPLE UTILISATION     **
 **     ET   IMPLEMENTATION     **
 **     D'EFFET SONORE DANS     **
 **     UN  PROGRAMME  AVEC     **
 **     LE KIT HUC POUR PCE     **
 *********************************
 ** Tutorial_son_n1  JyCet 2002 **
 *********************************/

#include "huc.h"
#include "tutorial_son_n1.h"

#define	AD_VAISSEAU	0x7000
#define	AD_MISSILE	0x7100
#define	NOTE		0x45

int son_final[32];
char son,channel;
char compteur;

wave_temp()
{
char temp;
for(temp=0 ; temp<32 ; temp++)
	poke(0x0806, sample[temp]);
}

initchannelwave()
{
	poke(0x0800, 0);
	poke(0x0805, 0x00);
	poke(0x0804, 0x0F);
	wave_temp();
	poke(0x0804, 0x8F);
	channel=1;
}

initchan()
{
	compteur=0;
	poke(0x0801, 0xFF);
	channel=0;

}

playsound()
{

	poke(0x0800, 0x0);
	if (compteur<32 && channel!=0)
		{
			poke(0x0805, volume[compteur]);
			poke(0x0803, (son_final[compteur]>>8)&0xF);
			poke(0x0802, (son_final[compteur])&0xFF);
		}
	else poke(0x0805, 0x00);

		compteur++;

	if (compteur>32)
		{
		compteur=0;
		son=0;
		}

}

calcul_final_sound()
{
	char i,temp;


	for (i=0;i<32;i++)
	{
		temp=(pitch[i]-127)+NOTE;
		son_final[i]=Mus_Notes[temp];
	}
}

main()
{
static char x_vaiss,y_vaiss,x_missi,y_missi,action;

disp_off();
init_satb();
cls();

x_vaiss=100;
x_missi=100;
y_vaiss=200;
y_missi=184;
action=0;

/*************************************
 * CHARGEMENT DES SPRITES EN MEMOIRE *
 *************************************/

	load_sprites(AD_VAISSEAU, vaisseau	, 1);
	load_sprites(AD_MISSILE	, missile	, 1);
	set_sprpal(0,sprites_colors);

	spr_set(0);
	spr_x(x_vaiss);
	spr_y(y_vaiss);
	spr_pattern(AD_VAISSEAU);
	spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_16x16|NO_FLIP);
	spr_pal(0);
	spr_pri(1);

	spr_set(1);
	spr_x(x_missi);
	spr_y(y_missi);
	spr_pattern(AD_MISSILE);
	spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_16x16|NO_FLIP);
	spr_pal(0);
	spr_pri(1);
	spr_hide(1);

disp_on();
vsync(1);

initchan();
calcul_final_sound();
initchannelwave();
son=0;

	for (;;)
	{

		if (joy(0) & JOY_LEFT && x_vaiss>0)
			{
				x_vaiss-=2;
				if (action==0)
					x_missi=x_vaiss;
			}

		if (joy(0) & JOY_RGHT && x_vaiss<239)
			{
				x_vaiss+=2;
				if (action==0)
					x_missi=x_vaiss;
			}

		if (joytrg(0) & JOY_A && action==0)
			{
				spr_show(1);
				action=1;
				son=1;
			}
		if (action==1)
			{
				if(y_missi<=184)
				{
				y_missi-=4;
				spr_set(1);
				spr_x(x_missi);
				spr_y(y_missi);
				}
				if(y_missi>184)
				{
				spr_hide(1);
				y_missi=y_vaiss-16;
				x_missi=x_vaiss;
				action=0;
				}
			}

		switch(son)
		{
			case 1:
				playsound();
			break;
		}

		spr_set(0);
		spr_x(x_vaiss);

		vsync(1);
		satb_update();

	}

}

/***********************
 ***********************
 ****               ****
 ****    SPRITES    ****
 ****               ****
 ***********************
 ***********************/

#incspr(vaisseau,"sprites.pcx",0,0,1,1);
#incspr(missile,"sprites.pcx",0,16,1,1);
#incpal(sprites_colors,"sprites.pcx",0,1);

